#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Windows面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: 沐落 <cjx@bt.cn>
# +-------------------------------------------------------------------

import sys,os,re
setup_path = os.getenv("BT_PANEL")
os.chdir(setup_path);
sys.path.append("class/")
import public,db,time,json

class redis_main:
    __redis_conf_file = os.getenv("BT_SETUP") + "/redis/redis.windows.conf"

    # 检查redis是否已经设置密码
    def check_redis_passwd(self,conf):
        if not conf:
            return 0
        rep = "\nrequirepass\s+.*"
        if not re.search(rep,conf):
            return 2

    # 检查是否公网ip
    def check_public_ip(self,get):
        local_ip_rep = "^(127\.0\.0\.1)|(localhost)|(10\.\d{1,3}\.\d{1,3}\.\d{1,3})|(172\.((1[6-9])|(2\d)|(3[01]))\.\d{1,3}\.\d{1,3})|(192\.168\.\d{1,3}\.\d{1,3})$"
        if re.search(local_ip_rep,get.bind):
            return False
        return True

    # 检查redis是否需要强制设置密码
    def check_set_public_ip(self,get):
        if self.check_public_ip(get):
            return True

    #设置redis常用配置配置
    def SetRedisConf(self,get):
        redis_conf = public.readFile(self.__redis_conf_file)
        if self.check_set_public_ip(get):
            if not get.requirepass:
                return public.returnMsg(False, 'redis必须设置密码后才能监听公网ip！')
            check_pw = self.check_redis_passwd(redis_conf)
            if check_pw == 2 and not get.requirepass:
                return public.returnMsg(False, 'redis必须设置密码后才能监听公网ip！')
            if check_pw == 0:
                return public.returnMsg(False, '没有找到redis配置文件')
        conflist = []
        getdict = get.__dict__
        for i in getdict.keys():
            if i != "__module__" and i != "__doc__" and i != "data" and i != "args" and i != "action" and i != "s" and i != "name":
                getpost = {
                    "name": i,
                    "value": str(getdict[i])
                }
                conflist.append(getpost)
        print(conflist)
        for c in conflist:
            if c["name"] == "requirepass":
                prep = "[\~\`\/\=@\&\!\#\$\%\^\*\(\)\-\+\[\]\{\}\|\'\;\:\,\.\<\>]"
                if re.search(prep, c["value"]):
                    return public.returnMsg(False, '请不要输入特殊字符 ')
            if c["name"] == "bind":
                iprep = "(2(5[0-5]{1}|[0-4]\d{1})|[0-1]?\d{1,2})\.(2(5[0-5]{1}|[0-4]\d{1})|[0-1]?\d{1,2})\.(2(5[0-5]{1}|[0-4]\d{1})|[0-1]?\d{1,2})\.(2(5[0-5]{1}|[0-4]\d{1})|[0-1]?\d{1,2})"
                if not re.search(iprep,c["value"]):
                    return public.returnMsg(False, '请输入正确的IP地址')
            if c["name"] == "port":
                try:
                    if int(c["value"]) >= 65535 or int(c["value"]) < 1:
                        return public.returnMsg(False, '请输入正确的端口号')
                except:
                    return public.returnMsg(False, '请输入正确的端口号')

            keys = ["timeout", "databases", "maxclients", "maxmemory"]

            for k in keys:
                if c["name"] == k:
                    if k == "maxmemory":
                        try:
                            v = int(c["value"])
                            public.writeFile("data/redis.log", str(v))
                            if v == 0:
                                c["value"] = ""
                            else:
                                c["value"] = v * 1024 * 1024

                        except:
                            return public.returnMsg(False, '最大内存数请输入整数')
                    else:
                        try:
                            c["value"] = int(c["value"])
                        except:
                            return public.returnMsg(False, '设置 %s 请输入整数' % k)
            rep = "\n#?%s\s+([\w\.])+" % c["name"]
            data = re.search(rep,redis_conf)
            print(data,"\n#?%s\s+([\w\.])+" % c["name"])
            if data:
                if c["value"] == "":
                    redis_conf = re.sub(rep, "", redis_conf)
                new_conf = "\n%s %s" % (c["name"], c["value"])
                redis_conf = re.sub(rep, new_conf, redis_conf)
            else:
                if c["value"] != "":
                    rep = "# Redis configuration file example\n"

                    new_conf = "%s %s\n" % (c["name"], c["value"])
                    redis_conf = re.sub(rep, "%s%s" % (rep,new_conf), redis_conf)

        public.writeFile(self.__redis_conf_file,redis_conf)
        return public.returnMsg(True, '设置成功')

    def get_run_user(self,get):
        name = "redis"
        ret = public.ExecShell("sc qc {}".format(name))[0]
        data = {}
        data['web'] = name
        data['user'] = ''
        if ret.find('LocalSystem') >=0 :
            data['user'] = "system"
        elif ret.find('redis') >=0 :
            data['user'] = 'redis'
        return data


    '''
    修改运行用户

    '''
    def change_server_users(self,name,user = 'LocalSystem',password = None):
        import win32service
        scm = win32service.OpenSCManager(None, None,win32service.SC_MANAGER_ALL_ACCESS)
        if scm:
            svc = win32service.OpenService(scm, name,win32service.SC_MANAGER_ALL_ACCESS)
            if svc:
                win32service.ChangeServiceConfig(svc, win32service.SERVICE_NO_CHANGE,win32service.SERVICE_AUTO_START, win32service.SERVICE_NO_CHANGE, None, None, 0, None, user, password, None)


    def add_user(self,name,pwd,ps):
        import win32netcon, win32security
        import win32net, win32api, win32netcon

        is_user = False
        resume = 0
        while True:
            data, total, resume = win32net.NetUserEnum(None, 3, win32netcon.FILTER_NORMAL_ACCOUNT, resume)
            for user in data:
                if user['name'] == name:
                    is_user = True
                    break;
            if not resume: break

        if not is_user:

            d = {}
            d['name'] = name
            d['password'] = pwd
            d['comment'] = ps
            d['flags'] = win32netcon.UF_NORMAL_ACCOUNT | win32netcon.UF_SCRIPT | win32netcon.UF_DONT_EXPIRE_PASSWD | win32netcon.UF_PASSWD_CANT_CHANGE
            d['priv'] = win32netcon.USER_PRIV_USER
            win32net.NetUserAdd(None, 1, d)

            #设置用户允许登录服务
            handle = win32security.LsaOpenPolicy(None, win32security.POLICY_ALL_ACCESS)
            sid_obj, domain, tmp = win32security.LookupAccountName(None, name)
            win32security.LsaAddAccountRights(handle, sid_obj, ('SeServiceLogonRight',) )
            win32security.LsaClose( handle)

        else:

            ret = public.ExecShell('net user "{}" "{}"'.format(name,pwd))
            print(ret)
            print('net user "{}" "{}"'.format(name,pwd))
        return True

    #设置redis启动用户
    def set_run_user(self,get):
        _name = "redis"

        public.set_server_status('redis',"stop")
        self._version = public.readFile(os.getenv("BT_SETUP") + '/redis/version.pl');
        user = get.user
        if user == 'system':
            self.change_server_users('redis')
            ret_msg = "切换启动用户成功，当前使用SYSTEM权限启动，可能存在安全风险."
        else:
            pwd = '{}{}{}'.format(public.GetRandomString(64),public.GetRandomString1(32),public.GetRandomString2(32))
            ret = self.add_user('redis',pwd,'用于启动宝塔安装的程序,删除后会导致部分软件无法启动,请勿删除')
            if not ret: return public.returnMsg(True,"redis用户创建失败,请【修复面板】后重新操作，如失败，则检查创建用户是否被安全软件拦截.")

            self.change_server_users('redis','.\\redis',pwd)

            ret_msg = '注意：redis用户密码采用128位混淆加密，并且本地不保存密码，此用户仅用于启动redis服务，并无其他安全问题，请勿随意修改密码和删除，否则将导致目录权限混乱!'


        paths = [os.getenv("BT_SETUP") + '/redis']
        #只读权限
        flist = []
        for x in paths: public.get_paths(x,flist)
        try:
             #批量设置上层目录只读权限
            for f in flist:
                print("正在设置 %s 权限" % f)
                public.set_file_access(f,user,public.file_read,False)
        except :  pass

        for f in paths:
            if not os.path.exists(f): continue
            public.set_file_access(f,user,public.file_all,True)

        public.set_server_status('redis',"start")
        return public.returnMsg(True,ret_msg);


    # 读取常用配置
    def GetRedisConf(self,get):
        try:
            redis_conf = public.readFile(self.__redis_conf_file)
            result = []
            n=0
            ps = ["绑定IP(修改绑定IP可能会存在安全隐患)","绑定端口","空闲连接超时时间,0表示不断开","最大连接数","数据库数量","redis密码,留空代表没有设置密码","MB,最大使用内存，0表示不限制"]
            keys = ["bind","port","timeout","maxclients","databases","requirepass","maxmemory"]
            for k in keys:
                v = ""
                rep = "\n%s\s+([\w\.]+)" % k
                group = re.search(rep,redis_conf)
                if not group:
                    if k == "maxmemory":
                        v = "0"
                    if k == "maxclients":
                        v = "10000"
                    if k == "requirepass":
                        v = ""
                else:
                    if k == "maxmemory":
                        v = int(group.group(1)) / 1024 / 1024
                    else:
                        v = group.group(1)
                psstr = ps[n]
                n=n+1
                kv = {"name": k, "value": v, "ps": psstr}
                result.append(kv)
            return result
        except Exception as ex:
            return public.returnMsg(False, str(ex))

   # 读取持久化
    def GetRedisPersistence(self,get):
        redis_conf = public.readFile(self.__redis_conf_file)
        result = {}
        #获取RDB配置
        rdb = []
        save = re.search("\nsave[\w\s\n]+", redis_conf)
        try:
            save = save.group().split("\n")
            for i in save:
                if i:
                    i = i.split()
                    d = {"time": i[1], "keys": i[2]}
                    rdb.append(d)
            result["rdb"] = rdb
        except:
            result["rdb"] = [{"keys": "0", "time": "0"}, {"keys": "0", "time": "0"}, {"keys": "0", "time": "0"}]

        rdbdir = re.search("\ndir\s+(.+)",redis_conf)
        if not rdbdir:
            rdbdir = ""
        else:
            rdbdir = rdbdir.group(1)
        if rdbdir == "./":
            rdbdir =  os.getenv("BT_SETUP") + "\\redis"
        result["dir"] = rdbdir

        #获取AOF配置
        appendonly = "\nappendonly\s+(\w+)"
        appendonly = re.search(appendonly,redis_conf)
        if not appendonly:
            return public.returnMsg(False, "没有在redis配置中找到 [ appendonly ] 参数")
        appendonly = appendonly.group(1)
        appendfsync = "\nappendfsync\s+(\w+)"
        appendfsync = re.search(appendfsync, redis_conf)
        if not appendfsync:
            return public.returnMsg(False, "没有在redis配置中找到 [ appendfsync ] 参数")
        appendfsync=appendfsync.group(1)
        result["aof"] = {"appendonly":appendonly,"appendfsync":appendfsync}

        return result


    # 设置持久化配置
    def SetRedisPersistence(self,get):
        # 设置RDB持久化
        redis_conf = public.readFile(self.__redis_conf_file)
        conflist = []
        getdict = get.__dict__
        for i in getdict.keys():
            if i != "__module__" and i != "__doc__" and i != "data" and i != "args" and i != "action" and i !="name" and i != "s":
                getpost = {
                    "name": i,
                    "value": str(getdict[i])
                }
                conflist.append(getpost)
        print(conflist)
        for c in conflist:
            rep = "\n%s\s+[\w\.\/]+" % c["name"]
            if re.search(rep,redis_conf):
                if c["name"] == "dir":
                    if c["value"][-1] == "/":
                        c["value"] = c["value"][:-1]
                    c["value"] = c["value"] + "/redis_cache"
                    if os.path.exists(c["value"]): os.makedirs(c["value"])

                new_conf = "\n%s %s" % (c["name"],c["value"])
                redis_conf = re.sub(rep,new_conf,redis_conf)
            else:
                newrdb = ""
                if c["name"] == "rdb":
                    n = 0
                    for v in json.loads(c["value"]):
                        try:
                            if int(v["keys"]) == 0 and int(v["time"]) == 0:
                                n+=1
                        except:
                            return public.returnMsg(False, 'RDB参数请输入整数')
                        newrdb += "\nsave %s %s" % (v["keys"], v["time"])
                    newrdb += "\n"
                    if n != 0:
                        newrdb = '\nsave ""\n'
                    rep = "\nsave[\w\s\n\"]+"
                    redis_conf = re.sub(rep, newrdb, redis_conf)

                else:
                    if c["value"] != "":
                        rep = "# Redis configuration file example.\n"
                        new_conf = "%s %s\n" % (c["name"], c["value"])
                        redis_conf = re.sub(rep, "%s%s" % (rep,new_conf), redis_conf)

        public.writeFile(self.__redis_conf_file,redis_conf)
        return public.returnMsg(True, '设置成功,手动重启redis后生效')

    #取redis状态
    def GetRedisStatus(self,get):
        import re
        setup_path = public.GetConfigValue('setup_path')
        c = public.readFile(setup_path + '/redis/redis.windows.conf')

        ip = re.search('\n\s*bind\s+([\d\.]+)',c)
        if not ip: return public.returnMsg(False,"没有在redis配置中找到 [ bind ip ] 参数")
        ip = ip.group(1)
        port = re.findall('\n\s*port\s+(\d+)',c)
        if not port:
            return public.returnMsg(False, "没有在redis配置中找到 [ port ] 参数")
        port = port[0]

        password = re.findall('\n\s*requirepass\s+(.+)',c)
        if password:
            password = ' -a ' + password[0]
        else:
            password = ''
        data = public.ExecShell(setup_path + '/redis/redis-cli.exe -h 127.0.0.1 -p ' + str(port) + password + ' info')[0];
        res = [
               'tcp_port',
               'uptime_in_days',    #已运行天数
               'connected_clients', #连接的客户端数量
               'used_memory',       #Redis已分配的内存总量
               'used_memory_rss',   #Redis占用的系统内存总量
               'used_memory_peak',  #Redis所用内存的高峰值
               'mem_fragmentation_ratio',   #内存碎片比率
               'total_connections_received',#运行以来连接过的客户端的总数量
               'total_commands_processed',  #运行以来执行过的命令的总数量
               'instantaneous_ops_per_sec', #服务器每秒钟执行的命令数量
               'keyspace_hits',             #查找数据库键成功的次数
               'keyspace_misses',           #查找数据库键失败的次数
               'latest_fork_usec'           #最近一次 fork() 操作耗费的毫秒数
               ];
        data = data.split("\n");
        result = {}
        for d in data:
            if len(d)<3: continue;
            t = d.strip().split(':');
            if not t[0] in res: continue;
            result[t[0]] = t[1];
        return result;

    # 取文件配置
    def GetRedisFile(self,get):
        import files
        f = files.files()
        # print(f.GetFileBody(get))
        return f.GetFileBody(get)

    # 保存文件配置
    def SaveRedisFile(self,get):
        import files
        f = files.files()
        return f.SaveFileBody(get)

